/******************************************************************************
 * Product: Compiere ERP & CRM Smart Business Solution                        *
 * Copyright (C) 1999-2007 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software, you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY, without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program, if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 3600 Bridge Parkway #102, Redwood City, CA 94065, USA      *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/
package org.compiere.model;

/** Generated Model - DO NOT CHANGE */
import java.sql.*;
import java.math.*;
import org.compiere.framework.*;
import org.compiere.util.*;
/** Generated Model for AD_ChangeLog
 *  @author Jorg Janke (generated) 
 *  @version Release 3.0.0 - $Id: GenerateModel.java,v 1.1 2008/01/16 07:34:32 jrmt Exp $ */
public class X_AD_ChangeLog extends PO
{
/** Standard Constructor
@param ctx context
@param AD_ChangeLog_ID id
@param trxName transaction
*/
public X_AD_ChangeLog (Ctx ctx, int AD_ChangeLog_ID, String trxName)
{
super (ctx, AD_ChangeLog_ID, trxName);
/** if (AD_ChangeLog_ID == 0)
{
setAD_ChangeLog_ID (0);
setAD_Column_ID (0);
setAD_Session_ID (0);
setAD_Table_ID (0);
setIsCustomization (false);
setRecord_ID (0);
}
 */
}
/** Load Constructor 
@param ctx context
@param rs result set 
@param trxName transaction
*/
public X_AD_ChangeLog (Ctx ctx, ResultSet rs, String trxName)
{
super (ctx, rs, trxName);
}
/** Serial Version No */
static final long serialVersionUID = 27466986481789L;
/** Last Updated Timestamp 2007-07-20 01:06:05.0 */
public static final long updatedMS = 1184861165000L;
/** AD_Table_ID=580 */
public static final int Table_ID=580;

/** TableName=AD_ChangeLog */
public static final String Table_Name="AD_ChangeLog";

protected static KeyNamePair Model = new KeyNamePair(580,"AD_ChangeLog");

protected BigDecimal accessLevel = new BigDecimal(6);
/** AccessLevel
@return 6 - System - Client 
*/
protected int get_AccessLevel()
{
return accessLevel.intValue();
}
/** Load Meta Data
@param ctx context
@return PO Info
*/
protected POInfo initPO (Ctx ctx)
{
POInfo poi = POInfo.getPOInfo (ctx, Table_ID);
return poi;
}
/** Info
@return info
*/
public String toString()
{
StringBuffer sb = new StringBuffer ("X_AD_ChangeLog[").append(get_ID()).append("]");
return sb.toString();
}
/** Set Change Log.
@param AD_ChangeLog_ID Log of data changes */
public void setAD_ChangeLog_ID (int AD_ChangeLog_ID)
{
if (AD_ChangeLog_ID < 1) throw new IllegalArgumentException ("AD_ChangeLog_ID is mandatory.");
set_ValueNoCheck ("AD_ChangeLog_ID", new Integer(AD_ChangeLog_ID));
}
/** Get Change Log.
@return Log of data changes */
public int getAD_ChangeLog_ID() 
{
Integer ii = (Integer)get_Value("AD_ChangeLog_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Set Column.
@param AD_Column_ID Column in the table */
public void setAD_Column_ID (int AD_Column_ID)
{
if (AD_Column_ID < 1) throw new IllegalArgumentException ("AD_Column_ID is mandatory.");
set_ValueNoCheck ("AD_Column_ID", new Integer(AD_Column_ID));
}
/** Get Column.
@return Column in the table */
public int getAD_Column_ID() 
{
Integer ii = (Integer)get_Value("AD_Column_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Set Role.
@param AD_Role_ID Responsibility Role */
public void setAD_Role_ID (int AD_Role_ID)
{
if (AD_Role_ID <= 0) set_ValueNoCheck ("AD_Role_ID", null);
else
set_ValueNoCheck ("AD_Role_ID", new Integer(AD_Role_ID));
}
/** Get Role.
@return Responsibility Role */
public int getAD_Role_ID() 
{
Integer ii = (Integer)get_Value("AD_Role_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Set Session.
@param AD_Session_ID User Session Online or Web */
public void setAD_Session_ID (int AD_Session_ID)
{
if (AD_Session_ID < 1) throw new IllegalArgumentException ("AD_Session_ID is mandatory.");
set_ValueNoCheck ("AD_Session_ID", new Integer(AD_Session_ID));
}
/** Get Session.
@return User Session Online or Web */
public int getAD_Session_ID() 
{
Integer ii = (Integer)get_Value("AD_Session_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Get Record ID/ColumnName
@return ID/ColumnName pair */
public KeyNamePair getKeyNamePair() 
{
return new KeyNamePair(get_ID(), String.valueOf(getAD_Session_ID()));
}
/** Set Table.
@param AD_Table_ID Database Table information */
public void setAD_Table_ID (int AD_Table_ID)
{
if (AD_Table_ID < 1) throw new IllegalArgumentException ("AD_Table_ID is mandatory.");
set_ValueNoCheck ("AD_Table_ID", new Integer(AD_Table_ID));
}
/** Get Table.
@return Database Table information */
public int getAD_Table_ID() 
{
Integer ii = (Integer)get_Value("AD_Table_ID");
if (ii == null) return 0;
return ii.intValue();
}

/** ChangeLogType AD_Reference_ID=430 */
public static final int CHANGELOGTYPE_AD_Reference_ID=430;
/** Delete = D */
public static final String CHANGELOGTYPE_Delete = "D";
/** Insert = I */
public static final String CHANGELOGTYPE_Insert = "I";
/** Update = U */
public static final String CHANGELOGTYPE_Update = "U";
/** Is test a valid value.
@param test testvalue
@returns true if valid **/
public boolean isChangeLogTypeValid (String test)
{
return test == null || test.equals("D") || test.equals("I") || test.equals("U");
}
/** Set Change Log Type.
@param ChangeLogType Type of change */
public void setChangeLogType (String ChangeLogType)
{
if (!isChangeLogTypeValid(ChangeLogType))
throw new IllegalArgumentException ("ChangeLogType Invalid value - " + ChangeLogType + " - Reference_ID=430 - D - I - U");
if (ChangeLogType != null && ChangeLogType.length() > 1)
{
log.warning("Length > 1 - truncated");
ChangeLogType = ChangeLogType.substring(0,1);
}
set_ValueNoCheck ("ChangeLogType", ChangeLogType);
}
/** Get Change Log Type.
@return Type of change */
public String getChangeLogType() 
{
return (String)get_Value("ChangeLogType");
}
/** Set Description.
@param Description Optional short description of the record */
public void setDescription (String Description)
{
if (Description != null && Description.length() > 255)
{
log.warning("Length > 255 - truncated");
Description = Description.substring(0,255);
}
set_Value ("Description", Description);
}
/** Get Description.
@return Optional short description of the record */
public String getDescription() 
{
return (String)get_Value("Description");
}
/** Set Customization.
@param IsCustomization The change is a customization of the data dictionary and can be applied after Migration */
public void setIsCustomization (boolean IsCustomization)
{
set_Value ("IsCustomization", new Boolean(IsCustomization));
}
/** Get Customization.
@return The change is a customization of the data dictionary and can be applied after Migration */
public boolean isCustomization() 
{
Object oo = get_Value("IsCustomization");
if (oo != null) 
{
 if (oo instanceof Boolean) return ((Boolean)oo).booleanValue();
 return "Y".equals(oo);
}
return false;
}
/** Set New Value.
@param NewValue New field value */
public void setNewValue (String NewValue)
{
if (NewValue != null && NewValue.length() > 2000)
{
log.warning("Length > 2000 - truncated");
NewValue = NewValue.substring(0,2000);
}
set_ValueNoCheck ("NewValue", NewValue);
}
/** Get New Value.
@return New field value */
public String getNewValue() 
{
return (String)get_Value("NewValue");
}
/** Set Old Value.
@param OldValue The old file data */
public void setOldValue (String OldValue)
{
if (OldValue != null && OldValue.length() > 2000)
{
log.warning("Length > 2000 - truncated");
OldValue = OldValue.substring(0,2000);
}
set_ValueNoCheck ("OldValue", OldValue);
}
/** Get Old Value.
@return The old file data */
public String getOldValue() 
{
return (String)get_Value("OldValue");
}
/** Set Record Key.
@param Record2_ID Record Key (where clause) */
public void setRecord2_ID (String Record2_ID)
{
if (Record2_ID != null && Record2_ID.length() > 255)
{
log.warning("Length > 255 - truncated");
Record2_ID = Record2_ID.substring(0,255);
}
set_ValueNoCheck ("Record2_ID", Record2_ID);
}
/** Get Record Key.
@return Record Key (where clause) */
public String getRecord2_ID() 
{
return (String)get_Value("Record2_ID");
}
/** Set Record ID.
@param Record_ID Direct internal record ID */
public void setRecord_ID (int Record_ID)
{
if (Record_ID < 0) throw new IllegalArgumentException ("Record_ID is mandatory.");
set_ValueNoCheck ("Record_ID", new Integer(Record_ID));
}
/** Get Record ID.
@return Direct internal record ID */
public int getRecord_ID() 
{
Integer ii = (Integer)get_Value("Record_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Set Redo.
@param Redo Redo */
public void setRedo (String Redo)
{
if (Redo != null && Redo.length() > 1)
{
log.warning("Length > 1 - truncated");
Redo = Redo.substring(0,1);
}
set_Value ("Redo", Redo);
}
/** Get Redo.
@return Redo */
public String getRedo() 
{
return (String)get_Value("Redo");
}
/** Set Transaction.
@param TrxName Name of the transaction */
public void setTrxName (String TrxName)
{
if (TrxName != null && TrxName.length() > 60)
{
log.warning("Length > 60 - truncated");
TrxName = TrxName.substring(0,60);
}
set_ValueNoCheck ("TrxName", TrxName);
}
/** Get Transaction.
@return Name of the transaction */
public String getTrxName() 
{
return (String)get_Value("TrxName");
}
/** Set Undo.
@param Undo Undo */
public void setUndo (String Undo)
{
if (Undo != null && Undo.length() > 1)
{
log.warning("Length > 1 - truncated");
Undo = Undo.substring(0,1);
}
set_Value ("Undo", Undo);
}
/** Get Undo.
@return Undo */
public String getUndo() 
{
return (String)get_Value("Undo");
}
}
